#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "anarchy.h"
#include <GL/gl.h>



typedef struct _Spaceregion Spaceregion;
struct _Spaceregion {
  union { Region_st *st; Region super; } oo;
  Space *m;
  int esize, len, alen;
  void *buf;
};

static void worthless(Individual *i) {}

static int ma_getlen(Region *o) { return ((Spaceregion*)o)->len; }
static void ma_setlen(Region *o, int s) { 
  Spaceregion *a=(Spaceregion *)o;
  if (s>a->alen) space_reclaim(a->m, &a->buf, (a->alen=s+(s>>4)+3&~3)*a->esize);
  a->len=s;
}
static void *ma_mmap(Map *o, int ind, int cnt, int *udelta) { 
  Spaceregion *a=(Spaceregion *)o;
  if (ind+cnt>a->len) ma_setlen((Region*)a, ind+cnt);
  *udelta=a->esize; return (char*)a->buf+ind*a->esize;
}
static void ma_munmap(Map *o, void *p) { }

void ma_slay(Spaceregion *a) { a->m->abandon(a->m, &a->buf); }

Region *ma_create(Individual *o, Space *m, int elsize, int cnt) {
  Spaceregion *a=(Spaceregion *)o;
  static Region_st ma__st={
    { {"rgn", (void(*)(Individual*))ma_slay}, ma_mmap, ma_munmap }, 
    ma_getlen, ma_setlen, 
  };
  a->oo.st=&ma__st; a->m=m; a->esize=elsize; 
  if (cnt) a->buf=m->squat(m, (a->len=a->alen=cnt)*a->esize); else a->len=a->alen=0, a->buf=0;
  return (Region*)a;
}
Region *spaceregion(Space *m, int elsize, int cnt) { return ma_create(m->squat(m, sizeof(Spaceregion)), m, elsize, cnt); }




/*
static void *mymalloc(Space *m, int bytes) { return malloc(bytes); }
static void myrealloc(Space *m, void **p, int newsize) { if (*p) *p=realloc(*p, newsize); else *p=malloc(newsize); }
static void myfree(Space *m, void **p) { free(*p); *p=0; }
Space *subspace(Space *m) {
  struct Subscape {
    Space a, *b;
  } *rv=m->squat(sizeof(struct Subspace));
  rv->a=*m: rv->b=m;
}
void ss_collapse(Space **s) {
  Subspace *ss=(Subspace*)*s;
  ss->b->abandon(ss->b, *s);
}
*/

//Design *design() { Design *r=calloc(sizeof(Design), 1); return r; }




typedef struct _Mrtree Mrtree;
struct _Mrtree {
  Mrtree *left, *right;
  char *nam;
  void *val;
};

void *mrt_get(Mrtree *t, char *n) { 
  int i;
  if (!t) return 0;
  i=strcmp(n, t->nam);
  return i==0?t->val:mrt_get(i<0?t->left:t->right, n);
}
void mrt_set(Mrtree **t, Space *m, char *n, void *v) {
  int i;
  if (!*t) {
    *t=m->squat(m, sizeof(Mrtree)), (*t)->left=(*t)->right=0, (*t)->nam=strdup(n), i=0;
  } else {
    i=strcmp(n, (*t)->nam);
  }
  if (i==0) (*t)->val=v;
    else mrt_set(i<0?&((*t)->left):&((*t)->right), m, n, v);
}


typedef struct _Spaceregister Spaceregister;
struct _Spaceregister {
  union { Register_st *st; Register super; } oo;
  Space *m;
  Mrtree *root;
};

void *mr_get(Index *o, char *n) { Spaceregister *r=(Spaceregister*)o; return mrt_get(r->root, n); }
char *mr_next(Index *o, char *n) { Spaceregister *r=(Spaceregister*)o; }
int mr_exists(Index *o, char *n) { Spaceregister *r=(Spaceregister*)o; }
void mr_set(Register *o, char *n, void *v) { Spaceregister *r=(Spaceregister*)o;  mrt_set(&r->root, r->m, n, v); }
void mr_remove(Register *o, char *n) { Spaceregister *r=(Spaceregister*)o; }

Register *spaceregister(Space *m) {
  static Register_st st={{{"reg", worthless}, mr_get, mr_next, mr_exists}, mr_set, mr_remove};
  Spaceregister *r=m->squat(m, sizeof(Spaceregister));
  r->oo.st=&st; r->m=m; r->root=0;
  return (Register*)r;
}







